{ ********************************************************************

    ॠ ८ࠧ  .

  ८ࠧ ந室   楤 SetCase  ࠬࠬ:
  - TheWord: 室 䠬,   ⢮. ⮢ ஡
             ⨬. 砭   ࠭  묨
             㪢;
  - TheCase:  (⠭ csXXXX),   㤥 ८ࠧ
             ᫮;
  - Gender:  த (⠭ gdXXXX). 筮 㪠뢠 ᪨ 
             ᪮ த;
  - Name:    ⠭ nmXXXX ⠭  ᫥饩 ᨬ:
              䠬 -  ᮡ⢥ (nmOwn);
              , ⢠ -  ⥫쭮 (nmNar);

  *** ਬ ***

  ଠ  :
  Fam - "৫类"   - 䠬
  Nam - "਩"     - 
  Ptn - "ᨫ쥢"  - ⢮
  Gnd - gdMasculine   - 

  祭   த⥫쭮 :
  Answer := SetCase (Fam, csGenitive, Gnd, nmOwn) + ' ' +
            SetCase (Nam, csGenitive, Gnd, nmNar) + ' ' +
            SetCase (Ptn, csGenitive, Gnd, nmNar);
  "৫类  ᨫ쥢"


  类 .. 2:4615/21.16

********************************************************************* }

Unit Morfolog;
interface

Const
       {  }
       csNominative     = 1;    { ⥫ - }
       csGenitive       = 2;    { ⥫  - }
       csDative         = 3;    { ⥫    - }
       csAccusative     = 4;    { ⥫  - }
       csInstrumentale  = 5;    { ⥫ - }
       csPreposizionale = 6;    { ।    -  }

       {  }
       gdMasculine = 0;         { ᪮ த }
       gdFeminine  = 1;         { ᪨ த }
       gdMedium    = 2;         { । த }
       gdPlural    = 3;         { ⢥ ᫮ }

       {  }
       nmNar = 0;               {  ⥫쭮 }
       nmOwn = 1;               {  ᮡ⢥   }

Function SetCase (TheWord: String; TheCase, Gender, Name: Word): String;

{ ************* } IMPLEMENTATION { *************** }

Type  TNMSet = array[csNominative..csPreposizionale] of String[3];
Const NMA: TNMSet = ('', '', '', '', '', '');
      NMB: TNMSet = ('', '', '', '', '', '');
      NMC: TNMSet = ('', '', '', '', '', '');
      NMD: TNMSet = ('', '', '', '', '', '');
      NME: TNMSet = ('',  '',  '',  '',  '',  '');
      NMF: TNMSet = ('',   '',  '',  '',  '',  '');

      NFA: TNMSet = ('', '', '', '', '', '');   { ... }
      NFB: TNMSet = ('', '', '', '', '', '');   { .. }
      NFC: TNMSet = ('', '', '', '', '', '');   { .. }

      OMA: TNMSet = ('', '', '', '', '', '');
      OMB: TNMSet = ('', '', '', '', '', '');
      OMC: TNMSet = ('', '', '', '', '', '');
      OMD: TNMSet = ('',   '',   '',   '',   '', '');

      OFA: TNMSet = ('', '', '', '', '', '');
      OFB: TNMSet = ('',  '', '', '',  '', '');


Function SetCase (TheWord: String; TheCase, Gender, Name: Word): String;
begin
  SetCase := TheWord;
  Case Name of
    nmNar: begin                  { ࠡ⪠  ⥫쭮 }
      Case Gender of
        gdMasculine: begin         { ᪮ த }
          { .., .., .., .., .., ⠫  ᮣ᭠ }
          if Copy (TheWord, Length(TheWord)-1, 2) = '' then begin
             Delete (TheWord, Length (TheWord)-1, 2);
             TheWord := TheWord + NMA[TheCase];
          end else
          if Copy (TheWord, Length(TheWord)-1, 2) = '' then begin
             Delete (TheWord, Length (TheWord)-1, 2);
             TheWord := TheWord + NMB[TheCase];
          end else
          if Copy (TheWord, Length(TheWord)-1, 2) = '' then begin
             Delete (TheWord, Length (TheWord)-1, 2);
             TheWord := TheWord + NMC[TheCase];
          end else
          if Copy (TheWord, Length(TheWord)-1, 2) = '' then begin
             Delete (TheWord, Length (TheWord)-1, 2);
             TheWord := TheWord + NMD[TheCase];
          end else
          if TheWord [Length(TheWord)] = '' then begin
             Dec (TheWord[0]);
             TheWord := TheWord + NME[TheCase];
          end else begin
             TheWord := TheWord + NMF[TheCase];
          end;
        end;
        gdFeminine: begin          { ᪨ த }
          { .., .., .., ⠫  .. }
          if TheWord [Length(TheWord)] <> '' then {  ᪫ }
          if TheWord [Length(TheWord)] = '' then begin
             Dec (TheWord[0]);
             TheWord := TheWord + NFA[TheCase];
          end else
          if Copy (TheWord, Length(TheWord)-1, 2) = '' then begin
             Dec (TheWord[0]);
             TheWord := TheWord + NFB[TheCase];
          end else begin
             Dec (TheWord[0]);
             TheWord := TheWord + NFC[TheCase];
          end;
        end;
        else Exit;
      end;
    end;
    nmOwn: begin                  { ࠡ⪠  ᮡ⢥ }
      Case Gender of
        gdMasculine: begin         { ᪮ த }
          { .., .., .., ⠫  ᮣ᭠ }
          if Copy (TheWord, Length(TheWord)-1, 2) = '' then begin
             Delete (TheWord, Length (TheWord)-1, 2);
             TheWord := TheWord + OMA[TheCase];
          end else
          if Copy (TheWord, Length(TheWord)-1, 2) = '' then begin
             Delete (TheWord, Length (TheWord)-1, 2);
             TheWord := TheWord + OMB[TheCase];
          end else
          if Copy (TheWord, Length(TheWord)-1, 2) = '' then begin
             Delete (TheWord, Length (TheWord)-1, 2);
             TheWord := TheWord + OMC[TheCase];
          end else begin
             TheWord := TheWord + OMD[TheCase];
          end;
        end;
        gdFeminine: begin          { ᪨ த }
          { .., ⠫  .. }
          if Copy (TheWord, Length(TheWord)-1, 2) = '' then begin
             Delete (TheWord, Length (TheWord)-1, 2);
             TheWord := TheWord + OFA[TheCase];
          end else begin
             Dec (TheWord[0]);
             TheWord := TheWord + OFB[TheCase];
          end;
        end;
        else Exit;
      end;
    end;
    else Exit;
  end;
  SetCase := TheWord;
end;

end.
